<?php

/**
 * Webkul Software.
 *
 * @category  Webkul
 * @package   Webkul_Eshopsync
 * @author    Webkul Software Private Limited
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\SalesforceConnector\Controller\Adminhtml\Orders;

use Webkul\SalesforceConnector\Helper\Order;

class ExportOrders extends \Magento\Backend\App\Action
{
    /** @var \Magento\Framework\View\Result\PageFactory */
    protected $_resultPageFactory;
    // protected $_categoryCollection;
    protected $_filter;
    protected $_helper;
    protected $_helperData;
    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Ui\Component\MassAction\Filter $filter,
        Order $helper
    ) {
        parent::__construct($context);
        $this->_resultPageFactory = $resultPageFactory;
        $this->_helper = $helper;
        $this->_filter = $filter;
    }

    public function execute()
    {
        $result = [
            'success' => 0,
            'err' => 0
        ];
        if (\Webkul\SalesforceConnector\Helper\Connection::checkConnectionStatus()) {
            $ids = $this->getRequest()->getParam('ids');
            if ($ids) {
                $sfId = $this->_helper->syncBulkOrders($ids);
            }
        } else {
            $this->messageManager
                ->addError(__("Check Connection"));
        }
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode($result));
    }
}
