<?php

namespace Webkul\SalesforceConnector\Helper;

use \Magento\Framework\App\Helper\AbstractHelper;
use \Magento\Store\Model\ScopeInterface;

/**
 *
 */
class Data extends AbstractHelper
{
    protected $_json;
    // protected $writerInterface;
    // protected $_curl;
    // protected $_scopeconfig;
    // protected $_sfconfigData;
    protected $_conn;
    // public $_logger;
    public $_authSession;
    protected $resourceConnection;

    const XML_PATH_SFCONNECTOR = 'sfConnect';

    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        \Magento\Backend\Model\Auth\Session $authSession,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        \Magento\Framework\App\ResourceConnection $resourceConnection,
        Connection $conn
    ) {
        parent::__construct($context);
        // $this->_logger = $logger;
        $this->_conn = $conn;
        $this->_authSession = $authSession;
        $this->resourceConnection = $resourceConnection;
        $this->_json = $jsonHelper;
    }
    public function getConfigValue($group, $field, $storeId = null)
    {
        return $this->scopeConfig->getValue(
            self::XML_PATH_SFCONNECTOR . '/' . $group . '/' . $field,
            ScopeInterface::SCOPE_STORE,
            $storeId
        );
    }
    public function getTableColumn($tableName)
    {
        $table = $this->resourceConnection->getTableName($tableName);
        // $query = "SELECT *
        // FROM INFORMATION_SCHEMA.COLUMNS
        // WHERE TABLE_NAME = 'customer_entity'";
        $query = "SHOW COLUMNS FROM $table";
        $results = $this->resourceConnection->getConnection()->fetchAll($query);
        return $results;
    }

    public static function fetchMappingDetails($model, $magentoId, $multi = false)
    {
        $data = [];
        if ($multi) {
            $mappingCollection = $model->create()->getCollection()
                ->addFieldToFilter('magento_id', ['in' => $magentoId]);
        } else {
            $mappingCollection = $model->create()->getCollection()
                ->addFieldToFilter('magento_id', ['eq' => $magentoId]);
        }
        if ($mappingCollection->getSize()) {
            // $mapping = $mappingCollection->getFirstItem();
            $data = $mappingCollection->getData();
        }
        return $data;
    }
    public function linkContentDocToSalesForce($sfID, $imageDocId)
    {
        if ($imageDocId) {
            $query = "SELECT ContentDocumentId FROM ContentVersion WHERE Id = '$imageDocId'";
            $sfContentDocumentExist = $this->_conn->getSObject($query);
            if (is_array($sfContentDocumentExist) && isset($sfContentDocumentExist['ContentDocumentId']) && !empty($sfContentDocumentExist['ContentDocumentId'])) {
                $isExist = $this->_conn->getSObject("SELECT Id FROM ContentDocumentLink WHERE ContentDocumentId = '" . $sfContentDocumentExist['ContentDocumentId'] . "' AND LinkedEntityId = '" . $sfID . "'");
                if (!isset($isExist['Id']) || empty($isExist['Id'])) {
                    $mediaLink = [];
                    $mediaLink['LinkedEntityId'] = $sfID;
                    $mediaLink['ShareType'] = 'I';
                    $mediaLink['Visibility'] = 'AllUsers';
                    $mediaLink['ContentDocumentId'] = $sfContentDocumentExist['ContentDocumentId'];
                    $cdocres = $this->_conn->insertSObject('ContentDocumentLink', $mediaLink);
                }
            }
        }
    }
    public function uploadImageToSalesForceFile($object, $magentoId, $imageUrl = false, &$reqArr)
    {
        if ($imageUrl) {
            if ($this->getConfigValue('catPdt', 'imgToFile')) {
                try {
                    $mediaImage = [];
                    $imagePath = pathinfo($imageUrl);
                    $name = $imagePath['basename'];
                    $mediaImage['Title'] = $name;
                    $mediaImage['VersionData'] = base64_encode(file_get_contents($imageUrl));
                    $query = "SELECT Id, Title from ContentVersion WHERE (Title='$name')";
                    $contentDocumentExist = $this->_conn->getSObject($query);

                    if (isset($contentDocumentExist['Id']) && !empty($contentDocumentExist['Id'])) {
                        return $contentDocumentExist['Id'];
                    } else {
                        $mediaImage['PathOnClient'] = $name;
                        $reqArr[] = [
                            'method' => 'POST',
                            'referenceId' => 'image_' . $magentoId,
                            'url' => '/services/data/v46.0/sobjects/ContentVersion/',
                            'body' => $mediaImage
                        ];
                        return true;
                        //return $this->_conn->insertSObject('ContentVersion', $mediaImage);
                    }
                } catch (\Exception $e) {
                    $error = "Export Error, $object Id " . $magentoId . " >>" . $e->getMessage();
                    self::eshopsyncLog($error);
                    return false;
                }
            } else {
                try {
                    $documentMedia = new \stdClass();
                    $imagePath = pathinfo($imageUrl);
                    $name = $imagePath['basename'];
                    $documentMedia->Name = $name;
                    $documentMedia->IsPublic = true;

                    $docFolder = $this->getConfigValue('catPdt', 'docFolder');

                    $documentMedia->FolderId = $this->_json->jsonDecode($docFolder)['id'];

                    $documentMedia->Body = base64_encode(file_get_contents($imageUrl));
                    $query = "SELECT Id FROM DOCUMENT WHERE Name='$name'";
                    $contentDocumentExist = $this->_conn->getSObject($query);
                    // if ($magentoId == 263) {
                    //     echo"<pre>";var_dump($contentDocumentExist);die;
                    // }
                    if (isset($contentDocumentExist['Id']) && !empty($contentDocumentExist['Id'])) {
                        $reqArr[] = [
                            'method' => 'PATCH',
                            'referenceId' => 'image_' . $magentoId,
                            'url' => '/services/data/v46.0/sobjects/Document/Id/' . $contentDocumentExist['Id'],
                            'body' => $documentMedia
                        ];
                        return true;
                        //$this->_conn->upsertSObject('Document', 'Id', $contentDocumentExist['Id'], $documentMedia);
                    } else {
                        $reqArr[] = [
                            'method' => 'POST',
                            'referenceId' => 'image_' . $magentoId,
                            'url' => '/services/data/v46.0/sobjects/Document/',
                            'body' => $documentMedia
                        ];
                        return true;
                    }
                } catch (\Exception $e) {
                    $error = "Export Error, Category Id " . $magentoId . " >>" . $e->getMessage();
                    self::eshopsyncLog($error);
                    return false;
                }
            }
        }
        return false;
    }
    public function checkFileExist($name = '')
    {
        if ($name) {
            $query = "SELECT Id, Title from ContentVersion WHERE (Title='$name')";
            $contentDocumentExist = $this->_conn->getSObject($query);
            if (isset($contentDocumentExist['Id']) && !empty($contentDocumentExist['Id'])) {
                return $contentDocumentExist['Id'];
            } else {
                return false;
            }
        }
    }
    public function checkMultiFileExist($titles = [])
    {
        if (count($titles) > 0) {
            $titleStr = '';
            foreach ($titles as $title) {
                if ($title == end($titles)) {
                    $titleStr .=  '\'' . $title . '\'';
                } else {
                    $titleStr .=  '\'' . $title . '\'' . ',';
                }
            }
            $query = "SELECT Id, Title from ContentVersion WHERE Title IN (" . $titleStr . ")";
            $contentDocumentExist = $this->_conn->getSObject($query, 0);

            if (isset($contentDocumentExist) && count($contentDocumentExist) > 0) {
                return array_column($contentDocumentExist, 'Title', 'Id');
            }
        }
        return [];
    }
    public function checkMultiDocExist($titles = [])
    {
        if (count($titles) > 0) {
            $titleStr = '';
            foreach ($titles as $title) {
                if ($title == end($titles)) {
                    $titleStr .=  '\'' . $title . '\'';
                } else {
                    $titleStr .=  '\'' . $title . '\'' . ',';
                }
            }
            $query = "SELECT Id, Name from DOCUMENT WHERE Name IN (" . $titleStr . ")";
            $contentDocumentExist = $this->_conn->getSObject($query, 0);

            if (isset($contentDocumentExist) && count($contentDocumentExist) > 0) {

                return array_column($contentDocumentExist, 'Name', 'Id');
            }
        }
        return [];
    }
    public static function eshopsyncLog($message = '')
    {
        if ($message) {
            $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
            $logger = $objectManager->create('Webkul\SalesforceConnector\Logger\EshopsyncLogger');
            $logger->critical($message);
        }
    }
    /**
     * Return the current user Id working from frontend or backend.
     *
     * @return String
     */
    public function getCurrentUser()
    {
        $user = $this->_authSession->getUser();
        if ($user) {
            return $user['user_id'];
        }
        return 0;
    }
    /**
     * Return the new array with push in right index and match key
     *
     * @return String
     */
    public function arrayMidPush($uniqueKey, $mainArr, $dataPush, $searchCol, $mediaLink)
    {
        $finalArr = [];
        $matchKey = array_search('cat_' . $uniqueKey, array_column($mainArr, $searchCol));
        $finalArr = array_slice($mainArr, 0, $matchKey - 1);
        $secndArr = array_slice($mainArr, $matchKey);
        array_push($finalArr, $dataPush);
        $mainData = array_shift($secndArr);

        $mainData['body']->webkul_es_mage__Category_Image_ID__c =  "@{image_" . $uniqueKey . ".id}";
        array_push($finalArr, $mainData);
        array_push($finalArr, $mediaLink);
        foreach ($secndArr as $data) {
            array_push($finalArr, $data);
        }
        return $finalArr;
    }
    public function bulkInsert($tableName, $data)
    {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $dbStorage = $objectManager->get('Webkul\SalesforceConnector\Model\Storage\DbStorage');
        $dbStorage->insertMultiple($tableName, $data);
    }
}
